package peakdetection;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import util.math.MathUtil;

public class SPB_Detection {
	public static double[] getB(ArrayList<Double> al, int idx1, int idx2) {
		double r[] = new double[16];
		double b2 = 0;
		double b1 = 0;
	//	double flag = 0;
	//	int idxmax = 0;	
		int idx0 = 0;
		double c0 = al.get(idx0);
		for(int i=0;i<idx1;i++){
			if(al.get(i)<al.get(idx1)&&al.get(i)<c0){
				idx0 = i;
				c0 = al.get(i);
				//break;
			}
		}
		int idxe = al.size()-1;
		double f2 = al.get(idx2);
		double f1 = al.get(idx1);
		double ce = al.get(idxe);
		for(int i=al.size()-1;i>idx2;i--){
			if(al.get(i)<ce&&al.get(i)<f2){
				idxe = i;
				ce = al.get(i);
				//break;
			}
		}
	//	double dmax = 0;
		int idxa2 = idx0;
		double dmax2 = 0;
		double dmax1 = 0;
		int idxa1 = idx0;
		for (int i = idx0; i <= idx2; i++) {
			double fenmu = al.get(i) > 1 ? al.get(i) : 1;
			b2 += (1.0 * (f2 - c0) * i / (idx2 - idx0) + c0 - al.get(i))
					/ fenmu;
			double dt = Math.abs((f2 - c0) * (i - idx0) - (idx2 - idx0)
					* al.get(i) + (idx2 - idx0) * c0)
					/ Math.sqrt(Math.pow(f2 - c0, 2) + Math.pow(idx2 - idx0, 2));
			double y = (f2 - c0)*(i-idx0)/(idx2-idx0)+c0;
			if (dmax2 < dt&&y>al.get(i)) {
				idxa2 = i;
				dmax2 = dt;
			}
		}

		for (int i = idx0; i <= idx1; i++) {
			double fenmu = al.get(i) > 1 ? al.get(i) : 1;
			b1 += (1.0 * (f1 - c0) * i / (idx1 - idx0) + c0 - al.get(i))
					/ fenmu;
			double dt = Math.abs((f1 - c0) * (i - idx0) - (idx1 - idx0)
					* al.get(i) + (idx1 - idx0) * c0)
					/ Math.sqrt(Math.pow(f1 - c0, 2) + Math.pow(idx1 - idx0, 2));
			double y = (f1 - c0)*(i-idx0)/(idx1-idx0)+c0;
			if (dmax1 < dt&&y>al.get(i)) {
				idxa1 = i;
				dmax1 = dt;
			}
		}
		int idxs1 = idx1;
		int idxs2 = idx2;
		double smax2 = 0;
		double smax1 = 0;
		for (int i = al.size() - 1; i > idx2; i--) {
			//double fenmu = al.get(i) > 1 ? al.get(i) : 1;
			//s2 += (1.0 * (f2 - c0) * i / (idx2 - idx0) + c0 - al.get(i))
			//		/ fenmu;
			double dt = Math.abs((f2 - ce) * (idxe - i) - (idxe - idx2)
					* al.get(i) + (idxe - idx2) * ce)
					/ Math.sqrt(Math.pow(f2 - ce, 2) + Math.pow(idxe - idx2, 2));
			double y = (f2 - ce)*(i-idxe)/(idx2-idxe)+ce;
			if (smax2 < dt&&y>al.get(i)) {
				idxs2 = i;
				smax2 = dt;
			}
		}

		ce = al.get(idxa2);
		idxe = idxa2;
		for(int i = idxa2;i>idx1;i--){
			if(al.get(i)<f1&&al.get(i)<ce){
				idxe = i;
				ce = al.get(i);
				//break;
			}
		}
		for (int i = idxe-1; i > idx1; i--) {
			//double fenmu = al.get(i) > 1 ? al.get(i) : 1;
			//s2 += (1.0 * (f2 - c0) * i / (idx2 - idx0) + c0 - al.get(i))
			//		/ fenmu;
			double dt = Math.abs((f1 - ce) * (idxe - i) - (idxe - idx1)
					* al.get(i) + (idxe - idx1) * ce)
					/ Math.sqrt(Math.pow(f1 - ce, 2) + Math.pow(idxe - idx1, 2));
			double y = (f1 - ce)*(i-idxe)/(idx1-idxe)+ce;
			if (smax1 < dt&&y>al.get(i)) {
				idxs1 = i;
				smax1 = dt;
			}
		}
		

		r[0] = idx0;
		r[1] = c0;
		r[2] = idxa1;
		r[3] = al.get(idxa1);
		r[4] = dmax1;
		
		r[5] = idxs1;
		r[6] = al.get(idxs1);
		r[7] = smax1;
		
		r[8] = b1;
		r[9] = idxa2;
		r[10] = dmax2;
		r[11] = al.get(idxa2);
		
		r[12] = idxs2;
		r[13] = al.get(idxs2);
		r[14] = smax1;
		
		r[15] = b2;
		/*r[5] = b1;
		r[6] = idxa2;
		r[7] = dmax2;
		r[8] = al.get(idxa2);
		r[9] = b2;*/

		// System.out.println(max+":"+min);
		return r;
	}
	

	public static double S(ArrayList<Double> al, int idx, int k) {
		double result = 0;
		int startidx = 0 > (idx - k) ? 0 : (idx - k);
		int end = al.size() - 1;
		int endidx = end < (idx + k) ? end : (idx + k);
		double max1 = 0;
		for (int i = startidx; i < idx; i++) {
			if ((al.get(idx) - al.get(i)) > max1) {
				max1 = al.get(idx) - al.get(i);
			}
		}
		double max2 = 0;
		for (int i = k + 1; i <= endidx; i++) {
			if ((al.get(idx) - al.get(i)) > max2) {
				max2 = al.get(idx) - al.get(i);
			}
		}
		result = (max1 + max2) / 2;
		return result;

	}

	public static ArrayList<Integer> SPD(ArrayList<Double> al, double h, int k) {

		double[] a = new double[al.size()];
		ArrayList<Integer> oo = new ArrayList<Integer>();
		for (int i = 0; i < al.size(); i++) {
			a[i] = S(al, i, k);
		}
		MathUtil mu = new MathUtil();
		double ave = mu.getMean(a);
		double sd = mu.getDeviation(a);
		for (int i = 0; i < al.size(); i++) {
			if (a[i] > 0 && (a[i] - ave) > h * sd) {
				oo.add(i);
			}
		}
		for (int i = 0; i < oo.size() - 1; i++) {
			if (oo.get(i + 1) - oo.get(i) <= k) {
				int min = al.get(oo.get(i + 1)) > al.get(oo.get(i)) ? i
						: (i + 1);
				oo.remove(min);
			}
		}
		return oo;
		// System.out.println(max+":"+min);
	}

	public static void main(String[] args) throws Exception, IOException {
		//String[] dwmlist = { "week", "day", "month" };
		//String[] gw = { "google", "wikipedia" };
		int len = 0;
		String pathin = "D:/experiment/sleep-beauty/time-series-data/";
		String path = "D:/experiment/sleep-beauty/empirical/";
		File[] filelist = new File(pathin).listFiles();
		for(File file:filelist){
			String filename = file.getName().substring(0,file.getName().length()-4);
		//for (String gwi : gw)
			//for (String dwm : dwmlist) {
				//String path = "D:/experiment/sleep-beauty/time-series-data/" + gwi + dwm
				//		+ ".txt";
				//BufferedReader br = new BufferedReader(new InputStreamReader(
				//		new FileInputStream(path), "utf-8"));
			    BufferedReader br = new BufferedReader(new InputStreamReader(
							new FileInputStream(file), "utf-8"));
				Set<String> set = new HashSet<String>();
				Map<String, String> mapkv = new HashMap<String, String>();
				Map<String, ArrayList<Double>> mapkv1 = new HashMap<String, ArrayList<Double>>();
				String str = "";
				double breakrate = 0.2;// ֵ
				int k = 5; // 5
				double h = 0.5; // 1.5

				String pathout = path +"sleep-feature/"+ filename+"_max0idx_max0fre_max1idx_max1fre_idxbreak_maxbreak_max2idx_max2fre_interval_rate_t1.txt";
				BufferedWriter bwout = new BufferedWriter(
						new OutputStreamWriter(new FileOutputStream(pathout),
								"utf-8"));
				String pathoutsample = path + "prediction/"+filename+"_m_ta_t.txt";
				BufferedWriter bwoutsample = new BufferedWriter(
						new OutputStreamWriter(new FileOutputStream(pathoutsample),
								"utf-8"));
				DecimalFormat df = new DecimalFormat("0.0000");
				// int cc = 0;
				HashMap<String, Integer> mapt1 = new HashMap<String, Integer>();
				HashMap<String, Integer> mapti = new HashMap<String, Integer>();
				while ((str = br.readLine()) != null) {
					String[] s = str.split("\t");
					ArrayList<Double> al = new ArrayList<Double>();
					String key = s[0];
					for (int i = 1; i < s.length; i++) {
						al.add(1.0 * Integer.parseInt(s[i]));
					}
					len = al.size();
					ArrayList<Integer> oo = SPD(al, h, k);
					double max2 = 0;
					double max1 = 0;
					int idx1 = 0;
					int idx2 = 0;

					if (oo.size() >= 2) {
						int temp = 0;
						for (int j = 0; j < oo.size(); j++) {
							if (max2 < al.get(oo.get(j))) {
								max2 = al.get(oo.get(j));
								idx2 = oo.get(j);
								temp = j;
							}
						}
						for (int i = 0; i < temp; i++) {
							if (max1 < al.get(oo.get(i))) {
								max1 = al.get(oo.get(i));
								idx1 = oo.get(i);
							}
						}
					}

					boolean flag = false;
					int idxbreak = 0;
					double maxbreak = max2;
					int idxover1 = 0;
					int idxover2 = 0;
					double m1 = 0;
					double m2 = 0;
					// if(max1>10&&idx1>=0&&idx2>=0&&max2>50){
					if (max1 > 5 && idx1 > 0 && idx2 > idx1
							&& 0.5 * max2 > max1) {
						// if(idx1>=0&&idx2>=0&&idx2>idx1&&al.get(idx2)>al.get(idx1)){
						for (int i = idx1 + 1; i < idx2; i++) {
							if (al.get(i) < 0.1 * max2) {
								flag = true;
								if (maxbreak > al.get(i)) {
									idxbreak = i;
									maxbreak = al.get(i);
								}
							}
						}
						for (int i = idx1 + 1; i <= idxbreak; i++) {
							if (al.get(i) < 0.2 * max1) {
								idxover1 = i;
								break;
							}
						}
						// if(idxover1 ==0){
						// idxover1 = idxbreak;
						// }
						for (int i = idx2 + 1; i < al.size(); i++) {
							if (al.get(i) < 0.2 * max2) {
								idxover2 = i;
								break;
							}
						}
					}

					// r[0] = idx0;
					// r[1] = c0;
					// r[2] = idxa1;
					// r[3] = al.get(idxa1);
					// r[4] = dmax1;
					// r[5] = b1;
					// r[6] = idxa2;
					// r[7] = dmax2;
					// r[8]= al.get(idxa2);
					// r[9] = b2;

//					r[0] = idx0;
//					r[1] = c0;
//					r[2] = idxa1;
//					r[3] = al.get(idxa1);
//					r[4] = dmax1;
//					
//					r[5] = idxs1;
//					r[6] = al.get(idxs1);
//					r[7] = smax1;
//					
//					r[8] = b1;
//					r[9] = idxa2;
//					r[10] = dmax2;
//					r[11] = al.get(idxa2);
//					
//					r[12] = idxs2;
//					r[13] = al.get(idxs2);
//					r[14] = smax1;
//					
//					r[15] = b2;
					if (flag) {
						double[] r = getB(al, idx1, idx2);
					/*	if (r[2] < idx1 && idx1 < r[6] && r[6] < idx2
								&& r[9] > r[5] && r[5] > 0 && idxover1 > 0
								&& idxover2 > 0) {*/
						if(r[2]>r[0]&&r[5]>idx1&&r[9]>idx1&&idx2>r[9]&&r[12]>idx2&&r[15]>r[8]&&set.add(key)){
							Double max0 = 0.0;
							int idx0 = 0;
							for (int j = 0; j < al.size(); j++) {
								if (al.get(j) > 0) {
									idx0 = j;
									max0 = al.get(j);
									break;
								}
							}

							for (int i = (int) r[2]; i < r[5]; i++) {//idxover1,r[6]
								m1 += al.get(i);
							}
							for (int i = (int) r[9]; i < r[12]; i++) {//idxover2,al.size()
								m2 += al.get(i);
							}
							int timeinterval = (int) (idx2 - idx1);
							int t1 = (int) idx1 - idx0;
							double rate = max1 / max2;
							// int t1interval = (int) (b[2] - b[0]);
							double p1 =al.get((int)r[2]);
							if(p1==0){
								p1 = al.get((int)r[2]+1);
							}
							double p2 =al.get((int)r[9]);
							if(p2==0){
								p2 = al.get((int)r[9]+1);
							}
							bwout.append(key + "\t" + idx0 + "\t" + max0 + "\t"
									+ idx1 + "\t" + max1 + "\t" + idxbreak
									+ "\t" + maxbreak + "\t" + idx2 + "\t"
									+ max2 + "\t" + timeinterval + "\t"
									+ df.format(rate) + "\t" + (int) r[2]
									+ "\t" + (int)r[5] + "\t"
									+  p1 + "\t" + m1 + "\t"//al.get((int) r[2]+1)
									+ (int) r[9] + "\t" + (int)r[12] + "\t"
									+  p2 + "\t" + m2 + "\t"//al.get((int) r[9]+1)
									+ t1);
							bwout.newLine();
							
							bwoutsample.append((int)m1+"\t"+(int)m2+"\t"+(int)r[2]+"\t"+(int)r[9]+"\t"+idxbreak+"\t"+idx1+"\t"+idx2);
							bwoutsample.newLine();
							// System.out.println(key+"\t"+b[3]+"\t"+b[5]+"\t"+Integer.parseInt(s[(int)b[3]+1])+"\t"+Integer.parseInt(s[(int)b[5]+1]));
							// System.out.println("2:"+key+":"+b[0]+":"+b[1]);
							mapt1.put(key, (int) r[2]);
							mapti.put(key, (int) idx2);
							if(!mapkv1.containsKey(key))
								mapkv1.put(key, al);
							if(!mapkv.containsKey(key))
								mapkv.put(key, str);
						}
						

					}
					// System.out.println(Integer.parseInt(s[(int)b[2]+1])+"\t"+Integer.parseInt(s[(int)b[3]+1])+"\t"+Integer.parseInt(s[(int)b[4]+1])+"\t"+Integer.parseInt(s[(int)b[5]+1]));
				}
				bwout.close();
				bwoutsample.close();
			/*	String path2 = "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
						+ gwi
						+ "_fre_filter_"
						+ dwm
						+ "_"
						+ k
						+ "_"
						+ h
						+ ".txt";// "D:/data/literaturedataset/result/pre_halfyear_mi_sortedB_fre.txt";
						*/
				String path2 = path+"fre/"+filename+"_fre.txt";
				BufferedWriter bw2 = new BufferedWriter(new OutputStreamWriter(
						new FileOutputStream(path2), "utf-8"));
				// DecimalFormat df = new DecimalFormat("0.0000");
				for (String entry : set) {
					bw2.append(mapkv.get(entry));
					bw2.newLine();
				}
				bw2.close();
				/*String path3 = "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
						+ gwi
						+ "_fre_filter_"
						+ dwm
						+ "_"
						+ k
						+ "_"
						+ h
						+ "_align.txt";// "D:/data/literaturedataset/result/pre_halfyear_mi_sortedB_fre.txt";
				*/
				String path3 = path+"fre/"+filename+"_fre_align.txt";
				BufferedWriter bw3 = new BufferedWriter(new OutputStreamWriter(
						new FileOutputStream(path3), "utf-8"));
				// DecimalFormat df = new DecimalFormat("0.0000");
				for (String entry : set) {
					ArrayList<Double> al = mapkv1.get(entry);
					int st = mapt1.get(entry);
					bw3.append(entry+"\t");
					for (int i = st; i < st+len; i++) {
						if (i < al.size()) {
							bw3.append((int)(double)al.get(i) + "\t");
						} else {
							bw3.append("0\t");
						}
					}
					bw3.newLine();

				}
				bw3.close();
			/*	String path4 = "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
						+ gwi
						+ "_fre_filter_"
						+ dwm
						+ "_"
						+ k
						+ "_"
						+ h
						+ "_align_p2.txt";// "D:/data/literaturedataset/result/pre_halfyear_mi_sortedB_fre.txt";
				BufferedWriter bw4 = new BufferedWriter(new OutputStreamWriter(
						new FileOutputStream(path4), "utf-8"));
				// DecimalFormat df = new DecimalFormat("0.0000");
				for (String entry : set) {
					ArrayList<Double> al = mapkv1.get(entry);
					int st = mapti.get(entry);
					for (int i = 0; i <al.size() ; i++) {
						//System.out.println(al.size()+"\t"+st+"\t"+i);
						if ((i-st) >=0 ) {
							//System.out.println(i-st);
							bw4.append((int)(double)al.get(i-st) + "\t");
						} else {
							bw4.append("0\t");
						}
					}
					bw4.newLine();

				}
				bw4.close();
				*/
				br.close();
			}
	}
}
